import win32.windows;
import win32frame.WindowBase ;


class PushButton : WindowBase {
  
  this(char[] name, HINSTANCE hInstance) {
    WNDCLASSEX  winc;
    winc.cbSize         = WNDCLASSEX.sizeof;
    winc.lpszClassName  = "BUTTON" ;
    super(name, winc) ;
  }

  int create( DWORD addstyle, int x, int y, int width, int height, HWND phwnd, HMENU hmenu){
    return( lowcreate( cast(uint)(0), (WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON | addstyle),
		       x, y, width, height, phwnd, hmenu ) ) ;
  }

  int getState() {
    return( SendMessage(this.hwnd, BM_GETCHECK , 0 , 0) ) ;
  }

  LRESULT proc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch (msg) {
    case WM_DESTROY:
      PostQuitMessage(0);
      break ;
    default :
      return( DefWindowProc(hwnd , msg , wp , lp) );
    }
    return(0);
  }
}
