import win32.windows;
import win32frame.WindowBase ;


class RadioButton : WindowBase {
  
  this(char[] name, HINSTANCE hInstance) {
    WNDCLASSEX  winc;
    winc.cbSize         = WNDCLASSEX.sizeof;
    winc.lpszClassName  = "BUTTON" ;
    super(name, winc) ;
  }

  int create( DWORD addstyle, int x, int y, int width, int height, HWND phwnd, HMENU hmenu){
    return( lowcreate( cast(uint)(0), (WS_CHILD | WS_VISIBLE | BS_AUTORADIOBUTTON | addstyle),
		       x, y, width, height, phwnd, hmenu ) ) ;
  }

  int getState() {
    return( SendMessage(this.hwnd, BM_GETCHECK , 0 , 0) ) ;
  }

  int setState(uint state) {
    return( SendMessage(this.hwnd, BM_SETCHECK , state , 0) ) ;
  }

  int enable() {
    return( EnableWindow(this.hwnd, TRUE) ) ;
  }

  int disable() {
    return( EnableWindow(this.hwnd, FALSE) ) ;
  }

}
