import win32.windows;
import win32.commctrl;
import win32frame.CommonControlBase;

class ToolBar : CommonControlBase {
  int created ;

  this(){
    created=0 ;
    super() ;
  }
  
  int create(DWORD style, HWND phwnd, int id, int img_num, TBBUTTON tbb[], int bt_num){
    if( created==0 ){
      this.hwnd = CreateToolbarEx( phwnd, WS_CHILD | WS_VISIBLE | style ,
				   id, img_num,
				   cast(HINSTANCE)(-1) ,
				   IDB_STD_SMALL_COLOR ,
				   tbb , bt_num , 0 , 0 , 0 , 0 , TBBUTTON.sizeof
				   ) ;
      if( this.hwnd==null ){
	return(-1) ;
      }
      created=1 ;
    }
    return(0) ;
  }

  int addButton( TBBUTTON tbb[], TBADDBITMAP tb, int bt_num ){
    if( created==1 ){
      if( this.hwnd!=null ){
	SendMessage(this.hwnd , TB_ADDBITMAP  , cast(WPARAM)(bt_num) , cast(LPARAM)(&tb) );
	SendMessage(this.hwnd , TB_ADDBUTTONS , cast(WPARAM)(bt_num) , cast(LPARAM)(&tbb[0]) );
      }
    }
    return(0) ;
  }

  void resize(UINT msg , WPARAM wp , LPARAM lp){
    if( this.hwnd!=null ){
      SendMessage(this.hwnd , msg, wp , lp);
    }
  }
}
