import win32.windows;
import WindowBase ;

class DialogBox : WindowBase {
  HWND parenthwnd ;

  int  dialog_res ;
  int  dialog_exit ;

  this( char[] name, WNDCLASSEX winc ) {
    this.dialog_res          = 0 ;
    this.dialog_exit         = 0 ;
    super(name, winc) ;
  }

  int create( DWORD style, int x, int y, int width, int height, HWND phwnd, HMENU hmenu){
    int res ;
    MSG msg;

    res=this.registwinc() ;
    if( res !=0 ){
      printf("wc regist faild.\n") ;
      return(res) ;
    }
    parenthwnd=phwnd ;
    res=lowcreate( cast(uint)(0), style, x, y, width, height, phwnd, hmenu ) ;
    if( res==0 ){
      EnableWindow(phwnd,FALSE);
      while(this.dialog_exit==0) {
	GetMessage(&msg,NULL,0,0);
	TranslateMessage(&msg);
	DispatchMessage(&msg);
	
      }
      EnableWindow(parenthwnd,TRUE);
      BringWindowToTop(parenthwnd);
    }else{
      return(res) ;
    }
    return( this.dialog_res ) ;
  }

  LRESULT proc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    return( DefWindowProc(hwnd , msg , wp , lp) );
  }

  void setResult(int res){
    this.dialog_res=res ;
    this.dialog_exit=1 ;
  }
}
